@echo off
:start
cls
echo ---------------- BUILD SCRIPT ----------------
echo    ADCH++ Batch Build Script Version 0.1.5
echo ---------------- BUILD SCRIPT ----------------
echo Choose an option 
echo (default will load in 10 seconds)
echo 1 Get Source
echo 2 Compile Source (default)
echo 3 Run diagnostics
choice /T 10 /C 123 /CS /D 2
if errorlevel 3 goto diag
if errorlevel 2 goto csrc
if errorlevel 1 goto gsrc

:csrc
echo Loading settings
rem ---------------- CONFIGURATION ----------------
set root=F:\dcdev_stuff\bzr\
set zip=%PROGRAMFILES%\7-Zip\7z.exe
set adchpp=F:\dcdev_stuff\bzr\adchpp\
set nightly_builds=F:\dcdev_stuff\bzr\nightly_builder\
set build=F:\dcdev_stuff\bzr\adchpp\build\
set export_dir=F:\dcdev_stuff\shared\adchpp\nightly_builds\
set clogs=F:\dcdev_stuff\compile_logs\adchpp\
rem ---------------- CONFIGURATION ----------------
echo Checking for updates
cd %adchpp%
call bzr pull lp:adchpp
call bzr revno > ..\bzr-revno.txt
set /p adchpp-revno= < ..\bzr-revno.txt
del %root%bzr-revno.txt
echo reversion number: %adchpp-revno%
pause
cls
echo beginning compiling script
:c0
echo on
call scons docs=1 > %clogs%docs_log_rev%adchpp-revno%.log
if errorlevel 1 goto cfail0
del %clogs%docs_log_rev%adchpp-revno%.log
:c1
echo on
call scons > %clogs%mingw_debug_log_rev%adchpp-revno%.log
if errorlevel 1 goto cfail1
del %clogs%mingw_debug_log_rev%adchpp-revno%.log
:c2
echo on
call scons mode=release > %clogs%mingw_release_log_rev%adchpp-revno%.log
if errorlevel 1 goto cfail2
del %clogs%mingw_release_log_rev%adchpp-revno%.log
:c3
echo on
call scons tools=default > %clogs%msvc_debug_86_log_rev%adchpp-revno%.log
if errorlevel 1 goto cfail3
del %clogs%msvc_debug_86_log_rev%adchpp-revno%.log
:c4
echo on
call scons tools=default mode=release > %clogs%msvc_release_86_log_rev%adchpp-revno%.log
if errorlevel 1 goto cfail4
del %clogs%msvc_release_86_log_rev%adchpp-revno%.log
:c5
echo on
call scons tools=default arch=x64 > %clogs%msvc_debug_64_log_rev%adchpp-revno%.log
if errorlevel 1 goto cfail5
del %clogs%msvc_debug_64_log_rev%adchpp-revno%.log
:c6
echo on
call scons tools=default mode=release arch=x64 > %clogs%msvc_release_64_log_rev%adchpp-revno%.log
if errorlevel 1 goto cfail6
del %clogs%msvc_release_64_log_rev%adchpp-revno%.log
:c7
@echo off
cls
echo removing unnessary files and copying nessary files and stripping executables
cd %build%debug-mingw\bin\
del /S *.a
mkdir config
mkdir Scripts
mkdir help
cd help
mkdir images
cd images
cd icons
cd %build%release-mingw\bin\
del /S *.a
mkdir config
mkdir Scripts
mkdir help
cd help
mkdir images
cd images
cd icons
cd %build%debug-default\bin\
del /S *.exp
del /S *.lib
mkdir config
mkdir Scripts
mkdir help
cd help
mkdir images
cd images
cd icons
cd %build%release-default\bin\
del /S *.exp
del /S *.lib
mkdir config
mkdir Scripts
mkdir help
cd help
mkdir images
cd images
cd icons
cd %build%debug-default-x64\bin\
del /S *.exp
del /S *.lib
mkdir config
mkdir Scripts
mkdir help
cd help
mkdir images
cd images
cd icons
cd %build%release-default-x64\bin\
del /S *.exp
del /S *.lib
mkdir config
mkdir Scripts
mkdir help
cd help
mkdir images
cd images
cd icons
cls
cd %adchpp%
copy *.txt "%build%debug-mingw\bin\"
copy *.txt "%build%release-mingw\bin\"
copy *.txt "%build%debug-default\bin\"
copy *.txt "%build%release-default\bin\"
copy *.txt "%build%debug-default-x64\bin\"
copy *.txt "%build%release-default-x64\bin\"
copy *.conf "%build%debug-mingw\bin\"
copy *.conf "%build%release-mingw\bin\"
copy *.conf "%build%debug-default\bin\"
copy *.conf "%build%release-default\bin\"
copy *.conf "%build%debug-default-x64\bin\"
copy *.conf "%build%release-default-x64\bin\"
cd %nightly_build%
copy *.txt "%build%debug-mingw\bin\config\"
copy *.txt "%build%release-mingw\bin\config\"
copy *.txt "%build%debug-default\bin\config\"
copy *.txt "%build%release-default\bin\config\"
copy *.txt "%build%debug-default-x64\bin\config\"
copy *.txt "%build%release-default-x64\bin\config\"
copy *.bat "%build%debug-mingw\bin\"
copy *.bat "%build%release-mingw\bin\"
copy *.bat "%build%debug-default\bin\"
copy *.bat "%build%release-default\bin\"
copy *.bat "%build%debug-default-x64\bin\"
copy *.bat "%build%release-default-x64\bin\"
copy *.url "%build%debug-default\bin\"
copy *.url "%build%release-default\bin\"
copy *.url "%build%debug-default-x64\bin\"
copy *.url "%build%release-default-x64\bin\"
cd %adchpp%etc\
copy *.xml "%mingw_debug_config%"
copy *.xml "%mingw_release_config%"
copy *.xml "%msvc_debug_86_config%"
copy *.xml "%msvc_release_86_config%"
copy *.xml "%msvc_debug_64_config%"
copy *.xml "%msvc_release_64_config%"
cd %adchpp%plugins\Script\examples\
copy *.lua "%build%debug-mingw\bin\Scripts\"
copy *.lua "%build%release-mingw\bin\Scripts\"
copy *.lua "%build%debug-default\bin\Scripts\"
copy *.lua "%build%release-default\bin\Scripts\"
copy *.lua "%build%debug-default-x64\bin\Scripts\"
copy *.lua "%build%release-default-x64\bin\Scripts\"
cd %adchpp%build\docs\user_guide\
copy *.html "%build%debug-mingw\bin\help\"
copy *.html "%build%release-mingw\bin\help\"
copy *.html "%build%debug-default\bin\help\"
copy *.html "%build%release-default\bin\help\"
copy *.html "%build%debug-default-x64\bin\help\"
copy *.html "%build%release-default-x64\bin\help\"
cd %adchpp%build\docs\user_guide\images\
copy *.png "%build%debug-mingw\bin\help\images\"
copy *.png "%build%release-mingw\bin\help\images\"
copy *.png "%build%debug-default\bin\help\images\"
copy *.png "%build%release-default\bin\help\images\"
copy *.png "%build%debug-default-x64\bin\help\images\"
copy *.png "%build%release-default-x64\bin\help\images\"
cd %adchpp%build\docs\user_guide\images\icons\
copy *.png "%build%debug-mingw\bin\help\images\icons\"
copy *.png "%build%release-mingw\bin\help\images\icons\"
copy *.png "%build%debug-default\bin\help\images\icons\"
copy *.png "%build%release-default\bin\help\images\icons\"
copy *.png "%build%debug-default-x64\bin\help\images\icons\"
copy *.png "%build%release-default-x64\bin\help\images\icons\"
if not exist "%zip%" (
   echo 7zip isnt found make sure path is correct, exiting...
   pause
   exit
)
echo 7zip is found going ahead with compression for the builds
echo compressing adchpp into archives
cd %build%debug-mingw\bin\
call "%zip%" a adchpp_rev_%adchpp-revno%_mingw_debug_version.zip
if errorlevel 1 goto zfail
copy *.zip "%export_dir%mingw_builds\"
cd %build%release-mingw\bin\
call "%zip%" a adchpp_rev_%adchpp-revno%_mingw_release_version.zip
if errorlevel 1 goto zfail
copy *.zip "%export_dir%mingw_builds\"
cd %build%debug-default\bin\
call "%zip%" a adchpp_rev_%adchpp-revno%_msvc_debug_x86_version.zip
if errorlevel 1 goto zfail
copy *.zip "%export_dir%msvc_builds\"
cd %build%release-default\bin\
call "%zip%" a adchpp_rev_%adchpp-revno%_msvc_release_x86_version.zip
if errorlevel 1 goto zfail
copy *.zip "%export_dir%msvc_builds\"
cd %build%debug-default-x64\bin\
call "%zip%" a adchpp_rev_%adchpp-revno%_msvc_debug_x64_version.zip
if errorlevel 1 goto zfail
copy *.zip "%export_dir%msvc_builds\"
cd %build%release-default-x64\bin\
call "%zip%" a adchpp_rev_%adchpp-revno%_msvc_release_x64_version.zip
if errorlevel 1 goto zfail
copy *.zip "%export_dir%msvc_builds\"
cd %adchpp%
echo compressing source
call bzr export adchpp_rev_%adchpp-revno%_source.tar.gz
copy adchpp_rev_%adchpp-revno%_source.tar.gz "%export_dir%source\"
cls
rem ---------------- FILE TRANSFER ----------------
rem call ftp.exe -s:%root%adchpp_login.ftp
rem ---------------- FILE TRANSFER ----------------
if errorlevel 1 goto ffail
echo removing builds builds for adchpp
del adchpp_rev_%adchpp-revno%_source.tar.gz
del .sconsign.dblite
del vc90.pdb
echo on
call scons -c
if errorlevel 1 goto end
echo on
call scons mode=release -c
if errorlevel 1 goto end
echo on
call scons tools=default -c
if errorlevel 1 goto end
echo on
call scons tools=default mode=release -c
if errorlevel 1 goto end
echo on
call scons tools=default arch=x64 -c
if errorlevel 1 goto end
echo on
call scons tools=default mode=release arch=x64 -c
if errorlevel 1 goto end
cd %build%
del /S *.* /Q
exit

:gsrc
cls
call bzr branch lp:adchpp
goto start

:diag
cls
call scons --help
if errorlevel 1 goto sfail

call bzr 
if errorlevel 1 goto bfail

echo ---------------- DIAG TEST ----------------
echo    	ALL DIAGNOSTIC TEST PASSED
echo ---------------- DIAG TEST ----------------
pause
goto start

:sfail
echo scons not found
pause
goto end

:bfail
echo bzr not found
pause
goto end

:cfail0
echo compiling failed
pause
goto c1

:cfail1
echo compiling failed
pause
goto c2

:cfail2
echo compiling failed
pause
goto c3

:cfail3
echo compiling failed
pause
goto c4

:cfail4
echo compiling failed
pause
goto c5

:cfail5
echo compiling failed
pause
goto c6

:cfail6
echo compiling failed
pause
goto c7

:zfail
echo compressing failed
pause
goto end

:ffail
echo filetransfer failed
pause
goto end

:End
exit